//+-----------------------------------------------------------+
//|                               EURUSD Negative Breakout EA |
//|                                               version 0.4 |
//|                               Original idea from mushy999 |
//|                                    EA conversion by Azmel |
//|                                 Copyright  Forex-TSD.com |
//+-----------------------------------------------------------+
//| INSTRUCTIONS: Attach the EA to EURUSD M5 chart.           |
//+-----------------------------------------------------------+
//| VERSION HISTORY                                           |
//| 0.1   - Initial release.                                  |
//| 0.2   - Trade short/long, opposite breakout signal is stop|
//|         loss for currently open position.Opens only one   |
//|         poisiotn in breakout direction.                   |
//| 0.3   - Added trailing stop                               |
//| 0.4   - Added MM. Make everything as options              |
//+-----------------------------------------------------------+
#include <stdlib.mqh>

//EXTERNAL VARIABLES
extern int    Magic=327697;
extern int    HighLowBars=65;
extern string TS         = ":: Trailing Stop Settings ::";
extern bool   UseTrailingStop= true;
extern int    trail_margin   = 20;
extern int    trail_every    =  5;
extern string TS1        = ":: Settings if not using Trailing Stop ::";
extern int    TakeProfit=80;
extern int    StopLoss=1000;
extern string MM         = ":: Money Management Settings ::";
extern bool   UseMoneyManagement= false;
extern int    Risk_percent      = 3;
extern double LotSize           =0.01;
extern double maxLots           = 100;
extern string  MAs         = ":: Moving Average Settings ::";
extern string  MAs1        = ":: Type 0=Simple 1=Exponential 2=Smoothed 3=Linear Wght";
extern string  MAs2        = ":: Price 0=Close 1=Open 2=High 3=Low 4=Median 5=Typical";
extern int    FirstMAPeriod=50;
extern int    SecondMAPeriod=166;
extern int    FirstMAType=2;
extern int    SecondMAType=2;
extern int    FirstPriceType=3;
extern int    SecondPriceType=0;
extern int    ThirdPriceType=2;
//extern int    PeriodsTillClose=310000;

int    counter;
//int    counter2=0;
double Low100;
double High100;
double Lots;
int    i;
int    slippage=5;
double FirstMA;
double SecondMA;
double ThirdMA;
double Price[2];

int init()
{
   Lots = LotSize;
   return(0);
}
int start()
{
   int   numorders = CountTrades();
//   int iOrders=OrdersTotal()-1;
//   counter2++;
   FirstMA=iMA(Symbol(),0,FirstMAPeriod,1,FirstMAType,FirstPriceType,1);
   SecondMA=iMA(Symbol(),0,SecondMAPeriod,1,SecondMAType,SecondPriceType,1);
   ThirdMA=iMA(Symbol(),0,FirstMAPeriod,1,FirstMAType,ThirdPriceType,1);
/*   
   if(counter2 > PeriodsTillClose)
   {
     for(i=iOrders; i>=0; i--) 
     {
       if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES) && (OrderType()<=OP_SELL) && GetMarketInfo() && !OrderClose(OrderTicket(),OrderLots(),Price[1-OrderType()],slippage)) Print(OrderError());
     }
     counter2=0;
   }
*/   
   if(numorders >0 && UseTrailingStop == true)
      trailing_stop();

   Call_MM();
         
   High100=0;
   Low100=999;

   for(i=1;i<=HighLowBars;i++)
   {
      High100=MathMax(High100,High[i]);
      Low100=MathMin(Low100,Low[i]);
   }
   Comment("High ", High100, " Low ", Low100);

   if(Ask>High100+1*Point )
   {
     if(numorders > 0 && OrderType() == OP_SELL && UseTrailingStop == true)
     {
         if(!OrderClose(OrderTicket(),OrderLots(),Ask,slippage))
         {
            Print(OrderError());
         }
     }
     if( numorders == 0 && FirstMA < SecondMA)
        if(!OrderSend(Symbol(),OP_BUY,Lots,Ask,slippage,Ask-StopLoss*Point,Ask+TakeProfit*Point,"EURUSD Breakout",Magic,0,Blue))
            Print(OrderError());
   }
   else
   if(Bid<Low100-1*Point)
   {
     if(numorders > 0 && OrderType() == OP_BUY && UseTrailingStop == true)
     {
         if(!OrderClose(OrderTicket(),OrderLots(),Bid,slippage))
         {
            Print(OrderError());
         }
     }     
     if( numorders == 0 && ThirdMA > SecondMA)
        if(!OrderSend(Symbol(),OP_SELL,Lots,Bid,slippage,Bid+StopLoss*Point,Bid-TakeProfit*Point,"EURUSD Breakout",Magic,0,Red))
            Print(OrderError());
   }


   return(0);
}

int CountTrades()
{
   counter=0;
   for(i=0;i<OrdersTotal();i++)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderMagicNumber()==Magic)
      {
         counter++;
         break;
      }
   }
   return(counter);
}


//+------------------------------------------------------------------+
//| Function..: OrderError                                           |
//+------------------------------------------------------------------+
string OrderError() {
  int iError=GetLastError();
  return(StringConcatenate("Order:",OrderTicket()," GetLastError()=",iError," ",ErrorDescription(iError)));
}
 
/*
//+------------------------------------------------------------------+
//| Function..: GetMarketInfo                                        |
//| Returns...: bool Success.                                        |
//+------------------------------------------------------------------+
bool GetMarketInfo() {
  RefreshRates();
  Price[0]=MarketInfo(OrderSymbol(),MODE_ASK);
  Price[1]=MarketInfo(OrderSymbol(),MODE_BID);
  double dPoint=MarketInfo(OrderSymbol(),MODE_POINT);
  if(dPoint==0) return(false);
  //giSlippage=(Price[0]-Price[1])/dPoint;
  return(Price[0]>0.0 && Price[1]>0.0);
}
*/
void trailing_stop()
{
    int     i;
    double  pt, bid, ask, step, profit, diff, new_sl;

        pt     = MarketInfo( OrderSymbol(), MODE_POINT );
        step   = trail_margin  * pt;
        diff   = (trail_margin + trail_every - 1) * pt;

        if( OrderType() == OP_BUY )
        {
            bid = MarketInfo( OrderSymbol(), MODE_BID );
            profit = bid - OrderOpenPrice();
            if( profit > step )
            {
                if( OrderStopLoss() < (bid - diff) )
                {
                    new_sl = bid - step;
                    OrderModify( OrderTicket(), OrderOpenPrice(), new_sl, 0, 0, CLR_NONE );
                    Print( "Modify SL=[",new_sl,"] at Bid=[",bid,"]");
                }
            }
        }
        else if( OrderType() == OP_SELL )
        {
            ask = MarketInfo( OrderSymbol(), MODE_ASK );
            profit = OrderOpenPrice() - ask;
            if( profit > step )
            {
                if( OrderStopLoss() > (ask + diff) )
                {
                    new_sl = ask + step;
                    OrderModify( OrderTicket(), OrderOpenPrice(), new_sl, 0, 0, CLR_NONE );
                    Print( "Modify SL=[",new_sl,"] at Ask=[",ask,"]");
                }
            }
        }

}

void Call_MM()
{
   if(UseMoneyManagement == false)
      return(0);
      
   Lots=AccountFreeMargin()/100000*Risk_percent;

   Lots=MathMin(maxLots,MathMax(LotSize,Lots));
   if(LotSize<0.1) 
     Lots=NormalizeDouble(Lots,2);               //   1k
   else
     {
     if(LotSize<1) Lots=NormalizeDouble(Lots,1); //  10k
     else          Lots=NormalizeDouble(Lots,0); // 100k
     }

   return(0);
}